definition module Incidone.OP.Concepts
//GENERATED BY CCL, DO NOT EDIT

import iTasks, iTasks.Extensions.Document, iTasks.Extensions.Contact, Database.SQL, Incidone.OP.ConceptsTOP, Incidone.OP.ConceptsSQL, Incidone.ContactPosition, Message.Encodings.AIS


:: AISStaticInfo :== AIVDM5
:: AISPosition :== AIVDMCNB
:: HelicopterType :== String
:: AirplaneType :== String
:: DiverDescription :== String
:: SurfSuitDescription :== String
:: SurfboardDescription :== String
:: VesselRange :== Miles
:: NextPortOfCall :== String
:: LastPortOfCall :== String
:: VesselSpeed :== Int
:: VesselCourse :== Int
:: VesselDestination :== String
:: VesselFuel :== String
:: VesselEngineType :== String
:: VesselPob :== Int
:: VesselDescription :== String
:: VesselType = Yacht | FishingVessel | CargoVessel | TowingVessel | PatrolVessel | RescueVessel | OtherVessel
:: MedicalHistory :== String
:: StateOfMind :== String
:: Injuries :== String
:: Nationality :== String
:: Gender = Male | Female
:: PersonAge :== Int
:: ContactPhotoAvatar :== Document
:: ContactPhotoThumb :== Document
:: ContactPhotoOriginal :== Document
:: CommunicationMeanType = CMPhone | CMVHF | CMEmail | CMP2000
:: CommunicationMeanId :== Int
:: ContactAccessLevel = WOAccess | PartnerAccess
:: ContactStatus = Alerted | Briefed | Proceeding | OnScene | StandbyOnLocation | OnTask | StandBy | Transfer | Released | Returned | LimitedAvailability | UnAvailable | Training | PreAlert
:: ContactNotes :== String
:: ContactHeading :== Degrees
:: ContactGroup :== String
:: ContactName :== String
:: ContactType = Person | Vessel | Surfer | Diver | Airplane | Helicopter | OtherContact
:: ContactNo :== Int
:: Barometric :== Int
:: CloudBase :== Feet
:: SeaTemperature :== Temperature
:: AirTemperature :== Temperature
:: WaveHeight :== Meters
:: SwellDirection :== Degrees
:: SeaState :== String
:: Visibility :== Feet
:: WindSpeed :== Knots
:: WindDirection :== String
:: WeatherType = Rain | Drizzle | Mist | Fog | Snow | Hail | Sunny | Haze | Cloudy | Showers | Thunderstorms
:: LogMessage :== String
:: IncidentType = AircraftAppearsInDifficulties | AircraftCollision | AircraftCrash | AircraftDitch | AircraftEmergency | AircraftOverdue | DiverInProblems | DiverMissing | DSCAlertInsideNLSRR | DSCAlertOutsideNLSRR | FalseAlertGoodIntent | FalseAlertMaliciousIntent | FamilyMessage | FlareSighted | INMARSATAlertInsideNLSRR | INMARSATAlertOutsideNLSRR | Medevac | MedicalAdvice | NRBTest | PersonAppearsInDifficulties | PersonBodyRecovery | PersonsInProblems | PersonsMissing | RigIncident | RigManOverboard | SARHeliUnavailable | SARTAlert | SurferAppearsInDifficulties | SurferInProblems | SurferMissing | VesselAppearsInDifficulties | VesselCapsized | VesselCollision | VesselEngineOrSteeringProblems | VesselFireOrExplosion | VesselManOverboard | VesselOverdue | VesselPiracyOrHijack | VesselSunk | VesselTakingWater | VesselUnsureOfPosition | YachtAground | YachtAppearsInDiffulties | YachtCapsized | YachtCollision | YachtEngineProblems | YachtFireOrExplosion | YachtGearFouled | YachtManOverboard
:: EmergencyPhase = INCERFA | ALERFA | DETRESFA
:: IncidentSummary :== String
:: IncidentTitle :== String
:: IncidentNo :== Int
:: INMARSATCActivation :== String
:: INMARSATStation :== Int
:: INMARSATNumber :== String
:: DSCCategory = DSCSafety | DSCRoutine | DSCUrgency | DSCDistress | DSCInvalid
:: DSCTeleCommand :== String
:: DSCWorkstation :== String
:: DSCNature :== String
:: DSCDistressId :== Int
:: DSCFormat :== Int
:: DSCRQI :== Int
:: DSCNumber :== Int
:: DSCCountry :== String
:: P2000Prio :== Int
:: P2000Body :== String
:: EmailBody :== String
:: EmailSubject :== String
:: EmailSender :== EmailAddress
:: EmailRecipient :== EmailAddress
:: PhoneCallReference :== String
:: CallNotes :== String
:: CommunicationStatus = Pending | Ringing | Connected | Answered | Missed | Sent
:: CommunicationDirection = In | Out
:: CommunicationType = PhoneCall | RadioCall | EmailMessage | P2000Message | DSCMessage
:: CommunicationNo :== Int
:: Degrees = Degrees !Int
:: Knots = Knots !Int
:: Miles = Miles !Int
:: Feet = Feet !Int
:: Meters = Meters !Int
:: Temperature = Temperature !Int
:: RadioChannel :== Int
:: CallSign :== String
:: PhoneNo :== String
:: HeadingInDegrees :== Int
:: SpeedInKnots :== Int
:: UTCDateTime :== DateTime
:: UTCTime :== Time
:: IMONumber :== Int
:: CapCode :== String
:: MMSI :== Int

:: EmailMessage =
	{recipient :: EmailRecipient
	,sender :: EmailSender
	,subject :: EmailSubject
	,body :: EmailBody
	}
:: P2000Message =
	{capCode :: CapCode
	,prio :: P2000Prio
	,body :: P2000Body
	}
:: DSCMessage =
	{callTime :: UTCDateTime
	,category :: DSCCategory
	,fromMmsi :: MMSI
	,fromCountry :: ?DSCCountry
	,no :: ?DSCNumber
	,rqi :: ?DSCRQI
	,format :: ?DSCFormat
	,distressId :: ?DSCDistressId
	,nature :: ?DSCNature
	,position :: ?ContactPosition
	,workstation :: ?DSCWorkstation
	,teleCmd :: ?DSCTeleCommand
	}
:: INMARSATCMessage =
	{inmarsatNo :: INMARSATNumber
	,toCes :: INMARSATStation
	,position :: ContactPosition
	,positionUpdated :: UTCTime
	,course :: ?HeadingInDegrees
	,speed :: ?SpeedInKnots
	,activation :: INMARSATCActivation
	,positionActivated :: Bool
	,courseSpeedActivated :: Bool
	}
:: PhoneCall =
	{externalNo :: ?PhoneNo
	,externalRef :: ?PhoneCallReference
	,callNotes :: ?CallNotes
	,communicationNo :: CommunicationNo
	}
:: RadioCall =
	{channel :: ?RadioChannel
	,callNotes :: ?CallNotes
	,communicationNo :: CommunicationNo
	}
:: Communication =
	{communicationNo :: CommunicationNo
	,time :: UTCDateTime
	,type :: CommunicationType
	,direction :: CommunicationDirection
	,handledBy :: ?ContactNo
	,status :: ?CommunicationStatus
	,withContact :: ?ContactNo
	,aboutIncidents :: [IncidentNo]
	}
:: CommunicationDetails =
	{communicationNo :: CommunicationNo
	,time :: UTCDateTime
	,type :: CommunicationType
	,direction :: CommunicationDirection
	,handledBy :: ?ContactShort
	,status :: ?CommunicationStatus
	,withContact :: ?ContactShort
	,aboutIncidents :: [IncidentShort]
	,externalNo :: ?PhoneNo
	}
:: Incident =
	{incidentNo :: IncidentNo
	,title :: ?IncidentTitle
	,summary :: ?IncidentSummary
	,type :: ?IncidentType
	,phase :: ?EmergencyPhase
	,weather :: WeatherData
	,log :: [LogEntry]
	,closed :: Bool
	,contacts :: [ContactNo]
	,communications :: [CommunicationNo]
	}
:: LogEntry =
	{incident :: IncidentNo
	,eventAt :: UTCDateTime
	,loggedAt :: UTCDateTime
	,loggedBy :: ?ContactAvatar
	,message :: LogMessage
	}
:: WeatherData =
	{weatherType :: ?WeatherType
	,windDirection :: ?WindDirection
	,windSpeed :: ?WindSpeed
	,visibility :: ?Visibility
	,seaState :: ?SeaState
	,swellDirection :: ?SwellDirection
	,waveHeight :: ?WaveHeight
	,airTemp :: ?AirTemperature
	,seaTemp :: ?SeaTemperature
	,cloudBase :: ?CloudBase
	,barometric :: ?Barometric
	}
:: Contact =
	{contactNo :: ContactNo
	,type :: ?ContactType
	,name :: ?ContactName
	,group :: ?ContactGroup
	,position :: ?ContactPosition
	,heading :: ?ContactHeading
	,track :: ?ContactTrack
	,positionUpdated :: ?UTCDateTime
	,needsHelp :: Bool
	,providesHelp :: Bool
	,communicationMeans :: [CommunicationMeanId]
	,photos :: [ContactPhoto]
	,notes :: ?ContactNotes
	,account :: ?Credentials
	,access :: ?ContactAccessLevel
	,status :: ?ContactStatus
	,communicationsWith :: [CommunicationNo]
	,incidents :: [IncidentNo]
	}
:: CommunicationMean =
	{id :: CommunicationMeanId
	,type :: CommunicationMeanType
	,capCode :: ?CapCode
	,emailAddress :: ?EmailAddress
	,callSign :: ?CallSign
	,mmsi :: ?MMSI
	,phoneNo :: ?PhoneNo
	}
:: TelephoneDetails =
	{phoneNo :: ?PhoneNo
	}
:: VHFRadioDetails =
	{callSign :: ?CallSign
	,mmsi :: ?MMSI
	}
:: EmailAccountDetails =
	{emailAddress :: ?EmailAddress
	}
:: P2000ReceiverDetails =
	{capCode :: ?CapCode
	}
:: ContactPhoto =
	{original :: ContactPhotoOriginal
	,thumb :: ContactPhotoThumb
	,avatar :: ContactPhotoAvatar
	}
:: PersonDetails =
	{age :: ?PersonAge
	,gender :: ?Gender
	,nationality :: ?Nationality
	,injuries :: ?Injuries
	,stateOfMind :: ?StateOfMind
	,medicalHistory :: ?MedicalHistory
	}
:: VesselDetails =
	{vesselType :: ?VesselType
	,imo :: ?IMONumber
	,inmarsatNo :: ?INMARSATNumber
	,description :: ?VesselDescription
	,pob :: ?VesselPob
	,engineType :: ?VesselEngineType
	,fuel :: ?VesselFuel
	,destination :: ?VesselDestination
	,course :: ?VesselCourse
	,speed :: ?VesselSpeed
	,lpc :: ?LastPortOfCall
	,npc :: ?NextPortOfCall
	,range :: ?VesselRange
	,lseOnBoard :: Bool
	,navaidsOnBoard :: Bool
	}
:: SurferDetails =
	{surfboardDescription :: ?SurfboardDescription
	,suitDescription :: ?SurfSuitDescription
	,age :: ?PersonAge
	,gender :: ?Gender
	,nationality :: ?Nationality
	,injuries :: ?Injuries
	,stateOfMind :: ?StateOfMind
	,medicalHistory :: ?MedicalHistory
	}
:: DiverDetails =
	{description :: ?DiverDescription
	}
:: AirplaneDetails =
	{callsign :: ?CallSign
	,planeType :: ?AirplaneType
	}
:: HelicopterDetails =
	{callsign :: ?CallSign
	,helicopterType :: ?HelicopterType
	}
:: AISContact =
	{mmsi :: MMSI
	,position :: ?ContactPosition
	,heading :: ?ContactHeading
	,track :: ?ContactTrack
	,lastPositionMsg :: ?AISPosition
	,lastInfoMsg :: ?AISStaticInfo
	,positionUpdated :: ?UTCDateTime
	,infoUpdated :: ?UTCDateTime
	}
:: IncidentShort =
	{incidentNo :: IncidentNo
	,title :: ?IncidentTitle
	}
:: IncidentBasic =
	{title :: ?IncidentTitle
	,summary :: ?IncidentSummary
	,type :: ?IncidentType
	,phase :: ?EmergencyPhase
	}
:: IncidentDetails =
	{incidentNo :: IncidentNo
	,title :: ?IncidentTitle
	,summary :: ?IncidentSummary
	,type :: ?IncidentType
	,phase :: ?EmergencyPhase
	}
:: ContactShort =
	{contactNo :: ContactNo
	,type :: ?ContactType
	,name :: ?ContactName
	,group :: ?ContactGroup
	}
:: ContactShortWithIncidents =
	{contactNo :: ContactNo
	,type :: ?ContactType
	,name :: ?ContactName
	,group :: ?ContactGroup
	,incidents :: [IncidentShort]
	}
:: ContactNameTypePosition =
	{type :: ?ContactType
	,name :: ?ContactName
	,position :: ?ContactPosition
	}
:: ContactBasic =
	{type :: ?ContactType
	,name :: ?ContactName
	,group :: ?ContactGroup
	,position :: ?ContactPosition
	,heading :: ?ContactHeading
	,needsHelp :: Bool
	,providesHelp :: Bool
	,notes :: ?ContactNotes
	,status :: ?ContactStatus
	}
:: ContactDetails =
	{contactNo :: ContactNo
	,type :: ?ContactType
	,name :: ?ContactName
	,position :: ?ContactPosition
	,notes :: ?ContactNotes
	}
:: ContactAvatar =
	{contactNo :: ContactNo
	,type :: ?ContactType
	,name :: ?ContactName
	,photos :: [ContactPhoto]
	}
:: ContactGeo =
	{contactNo :: ContactNo
	,type :: ?ContactType
	,name :: ?ContactName
	,group :: ?ContactGroup
	,position :: ?ContactPosition
	,heading :: ?ContactHeading
	,track :: ?ContactTrack
	,positionUpdated :: ?UTCDateTime
	,needsHelp :: Bool
	,providesHelp :: Bool
	}
:: ContactAccess =
	{account :: ?Credentials
	,access :: ?ContactAccessLevel
	}
:: NewContact =
	{type :: ?ContactType
	,name :: ?ContactName
	,position :: ?ContactPosition
	,needsHelp :: Bool
	}
:: NewIncident =
	{title :: ?IncidentTitle
	,summary :: ?IncidentSummary
	,type :: ?IncidentType
	}
:: NewCommunicationMean =
	{type :: CommunicationMeanType
	,capCode :: ?CapCode
	,emailAddress :: ?EmailAddress
	,callSign :: ?CallSign
	,mmsi :: ?MMSI
	,phoneNo :: ?PhoneNo
	}
class mbToSQL a where mbToSQL :: !(?a) -> [SQLValue]
class mbFromSQL a where mbFromSQL :: ![SQLValue] -> ?a
class toSQLRow a where toSQLRow :: !a -> [SQLValue]
class fromSQLRow a where fromSQLRow :: ![SQLValue] -> a
instance mbToSQL Int
instance mbToSQL String
instance mbToSQL Bool
instance mbFromSQL Int
instance mbFromSQL String
instance mbFromSQL Bool

instance mbToSQL VesselType where
	mbToSQL :: !(?VesselType) -> [SQLValue]
instance mbFromSQL VesselType where
	mbFromSQL :: ![SQLValue] -> ?VesselType

instance mbToSQL Gender where
	mbToSQL :: !(?Gender) -> [SQLValue]
instance mbFromSQL Gender where
	mbFromSQL :: ![SQLValue] -> ?Gender

instance mbToSQL CommunicationMeanType where
	mbToSQL :: !(?CommunicationMeanType) -> [SQLValue]
instance mbFromSQL CommunicationMeanType where
	mbFromSQL :: ![SQLValue] -> ?CommunicationMeanType

instance mbToSQL ContactAccessLevel where
	mbToSQL :: !(?ContactAccessLevel) -> [SQLValue]
instance mbFromSQL ContactAccessLevel where
	mbFromSQL :: ![SQLValue] -> ?ContactAccessLevel

instance mbToSQL ContactStatus where
	mbToSQL :: !(?ContactStatus) -> [SQLValue]
instance mbFromSQL ContactStatus where
	mbFromSQL :: ![SQLValue] -> ?ContactStatus

instance mbToSQL ContactType where
	mbToSQL :: !(?ContactType) -> [SQLValue]
instance mbFromSQL ContactType where
	mbFromSQL :: ![SQLValue] -> ?ContactType

instance mbToSQL WeatherType where
	mbToSQL :: !(?WeatherType) -> [SQLValue]
instance mbFromSQL WeatherType where
	mbFromSQL :: ![SQLValue] -> ?WeatherType

instance mbToSQL IncidentType where
	mbToSQL :: !(?IncidentType) -> [SQLValue]
instance mbFromSQL IncidentType where
	mbFromSQL :: ![SQLValue] -> ?IncidentType

instance mbToSQL EmergencyPhase where
	mbToSQL :: !(?EmergencyPhase) -> [SQLValue]
instance mbFromSQL EmergencyPhase where
	mbFromSQL :: ![SQLValue] -> ?EmergencyPhase

instance mbToSQL DSCCategory where
	mbToSQL :: !(?DSCCategory) -> [SQLValue]
instance mbFromSQL DSCCategory where
	mbFromSQL :: ![SQLValue] -> ?DSCCategory

instance mbToSQL CommunicationStatus where
	mbToSQL :: !(?CommunicationStatus) -> [SQLValue]
instance mbFromSQL CommunicationStatus where
	mbFromSQL :: ![SQLValue] -> ?CommunicationStatus

instance mbToSQL CommunicationDirection where
	mbToSQL :: !(?CommunicationDirection) -> [SQLValue]
instance mbFromSQL CommunicationDirection where
	mbFromSQL :: ![SQLValue] -> ?CommunicationDirection

instance mbToSQL CommunicationType where
	mbToSQL :: !(?CommunicationType) -> [SQLValue]
instance mbFromSQL CommunicationType where
	mbFromSQL :: ![SQLValue] -> ?CommunicationType

instance fromSQLRow EmailMessage where
	fromSQLRow :: ![SQLValue] -> EmailMessage // EmailMessage
instance toSQLRow EmailMessage where
	toSQLRow :: !EmailMessage -> [SQLValue] // EmailMessage

instance fromSQLRow P2000Message where
	fromSQLRow :: ![SQLValue] -> P2000Message // P2000Message
instance toSQLRow P2000Message where
	toSQLRow :: !P2000Message -> [SQLValue] // P2000Message

instance fromSQLRow WeatherData where
	fromSQLRow :: ![SQLValue] -> WeatherData // WeatherData
instance toSQLRow WeatherData where
	toSQLRow :: !WeatherData -> [SQLValue] // WeatherData

instance fromSQLRow TelephoneDetails where
	fromSQLRow :: ![SQLValue] -> TelephoneDetails // Telephone
instance toSQLRow TelephoneDetails where
	toSQLRow :: !TelephoneDetails -> [SQLValue] // Telephone

instance fromSQLRow VHFRadioDetails where
	fromSQLRow :: ![SQLValue] -> VHFRadioDetails // VHFRadio
instance toSQLRow VHFRadioDetails where
	toSQLRow :: !VHFRadioDetails -> [SQLValue] // VHFRadio

instance fromSQLRow EmailAccountDetails where
	fromSQLRow :: ![SQLValue] -> EmailAccountDetails // EmailAccount
instance toSQLRow EmailAccountDetails where
	toSQLRow :: !EmailAccountDetails -> [SQLValue] // EmailAccount

instance fromSQLRow P2000ReceiverDetails where
	fromSQLRow :: ![SQLValue] -> P2000ReceiverDetails // P2000Receiver
instance toSQLRow P2000ReceiverDetails where
	toSQLRow :: !P2000ReceiverDetails -> [SQLValue] // P2000Receiver

instance fromSQLRow ContactPhoto where
	fromSQLRow :: ![SQLValue] -> ContactPhoto // ContactPhoto
instance toSQLRow ContactPhoto where
	toSQLRow :: !ContactPhoto -> [SQLValue] // ContactPhoto

instance fromSQLRow PersonDetails where
	fromSQLRow :: ![SQLValue] -> PersonDetails // Person
instance toSQLRow PersonDetails where
	toSQLRow :: !PersonDetails -> [SQLValue] // Person

instance fromSQLRow VesselDetails where
	fromSQLRow :: ![SQLValue] -> VesselDetails // Vessel
instance toSQLRow VesselDetails where
	toSQLRow :: !VesselDetails -> [SQLValue] // Vessel

instance fromSQLRow SurferDetails where
	fromSQLRow :: ![SQLValue] -> SurferDetails // Surfer
instance toSQLRow SurferDetails where
	toSQLRow :: !SurferDetails -> [SQLValue] // Surfer

instance fromSQLRow DiverDetails where
	fromSQLRow :: ![SQLValue] -> DiverDetails // Diver
instance toSQLRow DiverDetails where
	toSQLRow :: !DiverDetails -> [SQLValue] // Diver

instance fromSQLRow AirplaneDetails where
	fromSQLRow :: ![SQLValue] -> AirplaneDetails // Airplane
instance toSQLRow AirplaneDetails where
	toSQLRow :: !AirplaneDetails -> [SQLValue] // Airplane

instance fromSQLRow HelicopterDetails where
	fromSQLRow :: ![SQLValue] -> HelicopterDetails // Helicopter
instance toSQLRow HelicopterDetails where
	toSQLRow :: !HelicopterDetails -> [SQLValue] // Helicopter

instance fromSQLRow IncidentShort where
	fromSQLRow :: ![SQLValue] -> IncidentShort // Incident
instance toSQLRow IncidentShort where
	toSQLRow :: !IncidentShort -> [SQLValue] // Incident

instance fromSQLRow IncidentBasic where
	fromSQLRow :: ![SQLValue] -> IncidentBasic // Incident
instance toSQLRow IncidentBasic where
	toSQLRow :: !IncidentBasic -> [SQLValue] // Incident

instance fromSQLRow IncidentDetails where
	fromSQLRow :: ![SQLValue] -> IncidentDetails // Incident
instance toSQLRow IncidentDetails where
	toSQLRow :: !IncidentDetails -> [SQLValue] // Incident

instance fromSQLRow ContactShort where
	fromSQLRow :: ![SQLValue] -> ContactShort // Contact
instance toSQLRow ContactShort where
	toSQLRow :: !ContactShort -> [SQLValue] // Contact

instance fromSQLRow ContactAccess where
	fromSQLRow :: ![SQLValue] -> ContactAccess // Contact
instance toSQLRow ContactAccess where
	toSQLRow :: !ContactAccess -> [SQLValue] // Contact

instance fromSQLRow NewIncident where
	fromSQLRow :: ![SQLValue] -> NewIncident // Incident
instance toSQLRow NewIncident where
	toSQLRow :: !NewIncident -> [SQLValue] // Incident

IncidoneDB :: SQLSchema
